/**************************************************** -*- linux-c -*- *
 *                  ParaStation
 *
 * Copyright (c) 2007 ParTec Cluster Competence Center GmbH
 * All rights reserved.
 **********************************************************************/
/**
 * $Id: pscom_debug.h 5258 2007-10-04 14:23:20Z hauke $
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 **********************************************************************/
#ifndef _PSCOM_DEBUG_H_
#define _PSCOM_DEBUG_H_

#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include "perf.h"

#define _DPRINT(fmt,pid,arg... ) do{			\
	fprintf(stderr, "<PSP%5d:"fmt">\n",pid ,##arg);	\
}while(0);

#define DPRINT(level,fmt,arg... ) do{				\
    if ((level)<=pscom.env.debug){				\
	fprintf(stderr, "<PSP%5d:"fmt">\n",getpid() ,##arg);	\
        fflush(stderr);						\
    }								\
}while(0);

#if 1
#define D_TR(code) do { } while (0)
#else
#define D_TR(code) do { code; } while (0)
#endif


void pscom_debug_init(void);

#endif /* _PSCOM_DEBUG_H_ */
