/**************************************************** -*- linux-c -*- *
 *                  ParaStation
 *
 * Copyright (c) 2007 ParTec Cluster Competence Center GmbH
 * All rights reserved.
 **********************************************************************/
/**
 * $Id: pscom_env.h 5307 2007-10-24 14:46:02Z hauke $
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 **********************************************************************/
#ifndef _PSCOM_ENV_H_
#define _PSCOM_ENV_H_


/* Set debuglevel */
#define ENV_DEBUG     "PSP_DEBUG"

/* Socket options */
#define ENV_SO_SNDBUF "PSP_SO_SNDBUF"
#define ENV_SO_RCVBUF "PSP_SO_RCVBUF"
#define ENV_TCP_NODELAY "PSP_TCP_NODELAY"

/* Call sched_yield() inside idle loop? 0: No 1: Yes. Default: 0 */
#define ENV_SCHED_YIELD "PSP_SCHED_YIELD"
/* Start rendezvous at messagesize x. Default ~0 = never */
#define ENV_RENDEZVOUS "PSP_RENDEZVOUS"
/* ENV_RENDEZVOUS_xxx: Messagesize for arch xxx.
   Default to ENV_RENDEZVOUS */
#define ENV_RENDEZVOUS_SHM "PSP_RENDEZVOUS_SHM"
#define ENV_RENDEZVOUS_DAPL "PSP_RENDEZVOUS_DAPL"
#define ENV_RENDEZVOUS_ELAN "PSP_RENDEZVOUS_ELAN"

/* Debugoutput on signal SIGQUIT (i386:3) (key: ^\) */ 
#define ENV_SIGQUIT "PSP_SIGQUIT"
#define ENV_READAHEAD "PSP_READAHEAD"
#define ENV_RETRY "PSP_RETRY"

#define ENV_PLUGINDIR "PSP_PLUGINDIR"
#define ENV_ARCH_PREFIX "PSP_"

/* Use this, if ENV_ARCH_NEW_SHM is not set */
#define ENV_ARCH_OLD_SHM "PSP_SHAREDMEM"
#define ENV_ARCH_NEW_SHM ENV_ARCH_PREFIX "SHM"

/* Use this, if ENV_ARCH_NEW_P4S is not set */
#define ENV_ARCH_OLD_P4S "PSP_P4SOCK"
#define ENV_ARCH_NEW_P4S ENV_ARCH_PREFIX "P4S"

/* The DAPL Provider to use */
#define ENV_DAPL_PROVIDER "PSP_DAPL_PROVIDER"



void pscom_env_get_int(int *val, char *name);
void pscom_env_get_uint(unsigned int *val, char *name);
void pscom_env_get_str(char **val, char *name);
void pscom_env_get_dir(char **val, char *name);

void pscom_env_init(void);

#endif /* _PSCOM_ENV_H_ */
