/*
 *               ParaStation
 *
 * Copyright (C) 2002-2004 ParTec AG, Karlsruhe
 * Copyright (C) 2005-2007 Cluster Competence Center GmbH, Munich
 * All rights reserved.
 *
 * $Id: pscom_p4s.h 5158 2007-08-24 16:21:22Z hauke $
 *
 * pscom_p4s.h: Header for p4sock communication
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 * @file
 ***********************************************************/

#ifndef _PSPORT_P4S_H_
#define _PSPORT_P4S_H_

#include "p4sockets.h"
#include "p4io.h"
#include "list.h"

typedef struct p4s_conn_s {
	int			p4s_con;
	struct list_head	con_sendq_next; // used by list p4s_sock_t.con_sendq
	int			reading : 1;
} p4s_conn_t;


typedef struct p4s_sock_s {
	int			fd;
	int			users;
	int			readers;
	int			ufd_idx;
	struct PSCOM_con	**p4s_conidx;
	int			p4s_conidx_cnt;
	struct sockaddr_p4	p4s_sockaddr;
	struct list_head	con_sendq;	// list of p4s_conn_t.con_sendq_next
	pscom_con_t		*recv_cur_con;
	int			recv_cur_con_idx;
} p4s_sock_t;


extern pscom_plugin_t pscom_plugin_p4s;

#endif /* _PSPORT_P4S_H_ */
