/***********************************************************
 *                  ParaStation4
 *
 *       Copyright (c) 2002 - 2004 ParTec AG Karlsruhe
 *
 * This software may be used and distributed according to
 * the terms of the GNU General Public License,
 * incorporated herein by reference.
 *
 ***********************************************************/
/**
 * bcm5700_glue.c: Connect the p4sock with the bcm5700 Module
 *
 * $Id: bcm5700_glue.c 4445 2006-11-20 14:19:06Z hauke $
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 * @file
 ***********************************************************/

#include <linux/stddef.h>
// #include <linux/config.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/types.h>
#include "p4prot_pub.h"
#include "p4ether_pub.h"

static char vcid[] __attribute__(( unused )) =
"$Id: bcm5700_glue.c 4445 2006-11-20 14:19:06Z hauke $";

MODULE_AUTHOR("ParTec AG, Jens Hauke <hauke@par-tec.de>");
MODULE_DESCRIPTION("ParaStation4 - Broadcom BCM5700 Glue");
#ifdef MODULE_LICENSE
MODULE_LICENSE("GPL");
#endif

void bcm5700_polling(void);

extern p4ether_netif_rx_t *bcm5700_netif_rx;
static p4ether_netif_rx_t *old_bcm5700_netif_rx;

static
p4_pollfunc_t bcm5700glue_poll = {
	.next = LIST_HEAD_INIT(bcm5700glue_poll.next),
	.func = bcm5700_polling
};

#if 0
static int bcm5700_new_netif_rx(struct sk_buff *skb)
{
    return old_bcm5700_netif_rx(skb);

    if (p4ether_netif_rx_try(skb)) {
	return old_bcm5700_netif_rx(skb);
    } else {
	if (net_ratelimit()) {
	    printk(KERN_INFO "bcm5700 fast path\n");
	}
	return 0;
    }
}
#endif

static int __init
bcm5700glue_init_module(void)
{
	p4_poll_add(&bcm5700glue_poll);
	old_bcm5700_netif_rx = bcm5700_netif_rx;
	bcm5700_netif_rx = /* bcm5700_new_netif_rx */ p4ether_netif_rx;
	return 0;
}

module_init(bcm5700glue_init_module);


static void __exit
bcm5700glue_exit_module(void)
{
	bcm5700_netif_rx = old_bcm5700_netif_rx;
	p4_poll_del(&bcm5700glue_poll);
}

module_exit(bcm5700glue_exit_module);

