/***********************************************************
 *                  ParaStation4
 *
 *       Copyright (c) 2002, 2003 ParTec AG Karlsruhe
 *
 * This software may be used and distributed according to
 * the terms of the GNU General Public License,
 * incorporated herein by reference.
 *
 ***********************************************************/
/**
 * e1000_glue.c: Connect the p4sock with the e1000 Module
 *
 * $Id: e1000_glue.c 4883 2007-06-14 12:13:44Z hauke $
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 * @file
 ***********************************************************/

#include <linux/stddef.h>
#include <linux/config.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/types.h>
#include "p4prot_pub.h"
#include "p4ether_pub.h"

static char vcid[] __attribute__(( unused )) =
"$Id: e1000_glue.c 4883 2007-06-14 12:13:44Z hauke $";

MODULE_AUTHOR("ParTec AG, Jens Hauke <hauke@par-tec.de>");
MODULE_DESCRIPTION("ParaStation4 - Intel(R) PRO/1000 Glue");
#ifdef MODULE_LICENSE
MODULE_LICENSE("GPL");
#endif

void e1000_poll(void);

extern p4ether_netif_rx_t *e1000_netif_rx;
static p4ether_netif_rx_t *old_e1000_netif_rx;

static
p4_pollfunc_t e1000glue_poll = {
	.next = LIST_HEAD_INIT(e1000glue_poll.next),
	.func = e1000_poll
};

    
static int __init
e1000glue_init_module(void)
{
	p4_poll_add(&e1000glue_poll);
	old_e1000_netif_rx = e1000_netif_rx;
	e1000_netif_rx = p4ether_netif_rx;
	return 0;
}

module_init(e1000glue_init_module);


static void __exit
e1000glue_exit_module(void)
{
	e1000_netif_rx = old_e1000_netif_rx;
	p4_poll_del(&e1000glue_poll);
}

module_exit(e1000glue_exit_module);

