/*
 *               ParaStation
 *
 * Copyright (C) 2002-2004 ParTec AG, Karlsruhe
 * Copyright (C) 2005 Cluster Competence Center GmbH, Munich
 * All rights reserved.
 *
 * $Id: p4proc.h 3540 2005-02-14 13:37:55Z hauke $
 *
 */

#ifndef _P4PROC4_H_
#define _P4PROC4_H_

#include <linux/sysctl.h>


extern struct ctl_table  ps4_sysctl_ps4_ether[];

void p4_proc_init(void);
void p4_proc_cleanup(void);

void p4_proc_add_ctl_table(ctl_table *ctl_table);
void p4_proc_del_ctl_table(ctl_table *ctl_table);

#define CTL_TABENTRY_MINMAX(_ctl_name, _procname, pvalvar, pminmax)	\
{ 									\
    ctl_name: _ctl_name,						\
    procname: _procname,						\
    data: pvalvar,							\
    maxlen: sizeof(*pvalvar),						\
    mode:0644,								\
    child: 0,								\
    proc_handler: &proc_dointvec_minmax,				\
    extra1: (void*)pminmax,						\
    extra2: (void*)(pminmax + 1),					\
}

#define CTL_TABENTRY_INTINFO(_ctl_name, _procname, pvalvar)		\
{ 									\
    ctl_name: _ctl_name,						\
    procname: _procname,						\
    data: pvalvar,							\
    maxlen: sizeof(*pvalvar),						\
    mode:0444,								\
    child: 0,								\
    proc_handler: &proc_dointvec,					\
}

extern int proc_ci_counter;
extern int proc_sock_alloc_cnt;
extern int proc_send_user_cnt;
extern int proc_send_net_data_cnt;// network part (p4ether, p4local....) must increment this counter!
extern int proc_send_net_ctrl_cnt;
extern int proc_send_net_ack_cnt;
extern int proc_send_net_nack_cnt;

extern int proc_timer_resend_cnt;
extern int proc_timer_ack_cnt;

extern int proc_recv_user_cnt;
extern int proc_recv_net_data_cnt;
extern int proc_recv_net_ctrl_cnt;
extern int proc_recv_net_ack_cnt;
extern int proc_recv_net_nack_cnt;

extern int proc_polling;

#endif
