/***********************************************************
 *                  ParaStation4
 *
 *       Copyright (c) 2002, 2003 ParTec AG Karlsruhe
 *
 * This software may be used and distributed according to
 * the terms of the GNU General Public License,
 * incorporated herein by reference.
 *
 ***********************************************************/
/**
 * tg3_glue.c: Connect the p4sock with the tg3 Module
 *
 * $Id: tg3_glue.c 4445 2006-11-20 14:19:06Z hauke $
 *
 * @author
 *         Jens Hauke <hauke@par-tec.de>
 *
 * @file
 ***********************************************************/

#include <linux/stddef.h>
// #include <linux/config.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/types.h>
#include "p4prot_pub.h"
#include "p4ether_pub.h"

static char vcid[] __attribute__(( unused )) =
"$Id: tg3_glue.c 4445 2006-11-20 14:19:06Z hauke $";

MODULE_AUTHOR("ParTec AG, Jens Hauke <hauke@par-tec.de>");
MODULE_DESCRIPTION("ParaStation4 - Intel(R) PRO/1000 Glue");
#ifdef MODULE_LICENSE
MODULE_LICENSE("GPL");
#endif

void tg3_polling(void);

extern p4ether_netif_rx_t *tg3_netif_rx;
static p4ether_netif_rx_t *old_tg3_netif_rx;

static
p4_pollfunc_t tg3glue_poll = {
	.next = LIST_HEAD_INIT(tg3glue_poll.next),
	.func = tg3_polling
};

static int tg3_new_netif_rx(struct sk_buff *skb)
{
    return old_tg3_netif_rx(skb);

    if (p4ether_netif_rx_try(skb)) {
	return old_tg3_netif_rx(skb);
    } else {
	if (net_ratelimit()) {
	    printk(KERN_INFO "tg3 fast path\n");
	}
	return 0;
    }
}
    
static int __init
tg3glue_init_module(void)
{
	p4_poll_add(&tg3glue_poll);
	old_tg3_netif_rx = tg3_netif_rx;
	tg3_netif_rx = tg3_new_netif_rx/* p4ether_netif_rx */;
	return 0;
}

module_init(tg3glue_init_module);


static void __exit
tg3glue_exit_module(void)
{
	tg3_netif_rx = old_tg3_netif_rx;
	p4_poll_del(&tg3glue_poll);
}

module_exit(tg3glue_exit_module);

