# -*- rpm-spec -*-
Summary:   ParaStation Cluster Communication drivers and libraries
Vendor:    ParTec Cluster Competence Center GmbH, Munich, Germany
Name:      pscom
Version:   5.0.12
Release:   0
License:   Proprietary
Group:     System/Development/Libraries
Packager:  support@par-tec.de
Source0:   %{name}-%{version}-%{release}.tar.gz
Requires:  psmgmt

# Dont use internal find_requires, because we dont want dependencies
# to the infiniband libs. (Searching for a clean solution!)
%define _use_internal_dependency_generator 0
%define __find_requires %_builddir/%{name}-%{version}-0/scripts/rpm_noreq

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}
 
%description
ParaStation Cluster Communication drivers and libraries.
%if %{?_without_modules:1}%{?_with_modules:1}%{?_with_e1000:1}%{?_with_bcm5700:1}0
(configured with %{?_without_modules} %{?_with_modules} %{?_with_e1000} %{?_with_bcm5700})
%endif
%prep

cat <<DOK
=====================================================
To build with kernel 2.x.y-z (default: uname -r) use:
>rpmbuild --define 'kernel 2.x.y-z'

To build ONLY modules use:
>rpmbuild --with modules

To build NO modules use:
>rpmbuild --without modules
=====================================================
>rpmbuild -with bcm5700 : build bcm5700 module
>rpmbuild -with e1000   : build e1000 module
DOK

%setup -q -n %{name}-%{version}-%{release}
#%setup -q
# %patch0 -p1


%post

%preun

%build

%configure --with-kernel=%{kernel} %{?_without_modules} %{?_with_modules} %{?_with_e1000} %{?_with_bcm5700}

%{__make}

%install
%{__rm} -rf %{buildroot}
%makeinstall

%clean
%{__rm} -rf %{buildroot}


#
# conditional build libs and bins
# Use: "rpmbuild --with modules" to build ONLY modules
#

%if %{?_with_modules:0}%{!?_with_modules:1}

%files
%attr(-,root,root) /opt/parastation

%endif

#
# conditional build modules
# Use: "rpmbuild --without modules" to disable this build
#

%if %{?_without_modules:0}%{!?_without_modules:1}

%define kver  %(echo %{kernel} | tr -s '-' '_')

%package modules
Summary: ParaStation Cluster Communication modules
Release: %{release}_%{kver}
Group: System Environment/Kernel
%description modules
This package provides kernel modules for package %{name}.
%if %{?_without_modules:1}%{?_with_modules:1}%{?_with_e1000:1}%{?_with_bcm5700:1}0
(configured with %{?_without_modules} %{?_with_modules} %{?_with_e1000} %{?_with_bcm5700})
%endif
%files modules
%attr(-,root,root) /lib/modules

%endif
